(require (lib "defmacro.ss"))

(define-macro when 
  (lambda (test . branch) 
    (list 'if test 
      (cons 'begin branch))))

(define-macro wrong-my-or
  (lambda (x y)
    `(let ((temp ,x))
       (if temp temp ,y))))

(define-macro my-or 
  (lambda (x y) 
    (let ((temp (gensym))) 
      `(let ((,temp ,x)) 
         (if ,temp ,temp ,y)))))

(define-macro fluid-let 
  (lambda (xexe . body) 
    (let ((xx (map car xexe)) 
          (ee (map cadr xexe)) 
          (old-xx (map (lambda (ig) (gensym)) xexe)) 
          (result (gensym))) 
      `(let ,(map (lambda (old-x x) `(,old-x ,x))  
                  old-xx xx) 
         ,@(map (lambda (x e) 
                  `(set! ,x ,e))  
                xx ee) 
         (let ((,result (begin ,@body))) 
           ,@(map (lambda (x old-x) 
                    `(set! ,x ,old-x))  
                  xx old-xx) 
           ,result)))))

(expand-once '(when (< x 0) (display "Less-than")))

(define temp 3)
(wrong-my-or #f temp)
(my-or #f temp)

(expand-once '(fluid-let ((x 9) (y (+ y 1))) 
  (+ x y)))