(load-relative "sos.scm")

(define bike-class 
  (create-class 
   #t 
   (frame size parts chain tires) 
   (check-fit (lambda (me inseam) 
                (let ((bike-size (slot-value me 'size)) 
                      (ideal-size (* inseam 3/5))) 
                  (let ((diff (- bike-size ideal-size))) 
                    (cond ((<= -1 diff 1) 'perfect-fit) 
                          ((<= -2 diff 2) 'fits-well) 
                          ((< diff -2) 'too-small) 
                          ((> diff 2) 'too-big)))))))) 

(define my-bike 
  (make-instance bike-class 
                 'frame 'titanium
                 'size 21 
                 'parts 'ultegra 
                 'chain 'sachs 
                 'tires 'continental)) 

(send 'check-fit my-bike 32) 

(define mtn-bike-class 
  (create-class 
    bike-class 
    (suspension) 
    (check-fit (lambda (me inseam) 
                (let ((bike-size (slot-value me 'size)) 
                      (ideal-size (- (* inseam 3/5) 2))) 
                  (let ((diff (- bike-size ideal-size))) 
                    (cond ((<= -2 diff 2) 'perfect-fit) 
                          ((<= -4 diff 4) 'fits-well) 
                          ((< diff -4) 'too-small) 
                          ((> diff 4) 'too-big)))))))) 
